public class UE7Aufgabe11Datei {

	final static int GROESSE = 9;

	public static void main(String[] args) {
		String dateiname = IO.readString("Dateiname: ");
		char[][] feld = IO.readFileAsCharMatrix(dateiname);
		if (feld == null) {
			IO.println("Fehlerhafte Datei!");
			return;
		}

		print(feld);
		sudoku(feld, 0);
	}

	static void sudoku(char[][] feld, int nummer) {
		if (voll(feld)) {
			// voll? -> Loesung gefunden
			print(feld);
		} else if (nummer >= GROESSE * GROESSE) {
			// REIHEN ueberschritten -> nicht loesbar
			return;
		} else if (feld[nummer / GROESSE][nummer % GROESSE] != '0') {
			// Feld besetzt != 0 -> naechstes Feld
			sudoku(feld, nummer + 1);
		} else {

			// sonst -> alle Ziffern durchprobieren -> Backtracking
			for (int z = 1; z <= GROESSE; z++) {
				char ziffer = (char) (z + '0');
				if (istMoeglich(feld, nummer / GROESSE, nummer % GROESSE,
						ziffer)) {
					feld[nummer / GROESSE][nummer % GROESSE] = ziffer;
					sudoku(feld, nummer + 1);
				}
			}
			feld[nummer / GROESSE][nummer % GROESSE] = '0';
		}

	}

	static void print(char[][] matrix) {
		for (int r = 0; r < matrix.length; r++) {
			for (int s = 0; s < matrix[r].length; s++) {
				System.out.print(matrix[r][s] + " ");
			}
			System.out.println();
		}
		System.out.println();
	}

	static boolean voll(char[][] matrix) {
		for (int r = 0; r < matrix.length; r++) {
			for (int s = 0; s < matrix[r].length; s++) {
				if (matrix[r][s] == '0') {
					return false;
				}
			}
		}
		return true;
	}

	static boolean istMoeglich(char[][] feld, int reihe, int spalte, char wert) {
		for (int i = 0; i < GROESSE; i++) {
			if (feld[reihe][i] == wert) {
				return false;
			}
		}
		for (int i = 0; i < GROESSE; i++) {
			if (feld[i][spalte] == wert) {
				return false;
			}
		}
		for (int i = reihe / 3 * 3; i < reihe / 3 * 3 + 3; i++) {
			for (int j = spalte / 3 * 3; j < spalte / 3 * 3 + 3; j++) {
				if (feld[i][j] == wert) {
					return false;
				}
			}
		}
		return true;
	}

}
