public class UE7Aufgabe17 {

	// Warshall-Algorithmus
	public static boolean[][] transitiveHuelle(boolean[][] matrix) {
		boolean[][] huelle = new boolean[matrix.length][matrix.length];
		for (int von = 0; von < matrix.length; von++) {
			for (int nach = 0; nach < matrix.length; nach++) {
				huelle[von][nach] = matrix[von][nach];
			}
		}
		for (int ueber = 0; ueber < matrix.length; ueber++) {
			for (int von = 0; von < matrix.length; von++) {
				for (int nach = 0; nach < matrix.length; nach++) {
					if (!huelle[von][nach] && huelle[von][ueber]
							&& huelle[ueber][nach]) {
						huelle[von][nach] = true;
					}
				}
			}
		}
		return huelle;
	}

	// "intuitiver" Algorithmus
	public static boolean[][] transitiveHuelle2(boolean[][] matrix) {
		boolean[][] huelle = new boolean[matrix.length][matrix.length];
		for (int von = 0; von < matrix.length; von++) {
			for (int nach = 0; nach < matrix.length; nach++) {
				huelle[von][nach] = matrix[von][nach];
			}
		}
		boolean veraendert;
		do {
			veraendert = false;
			for (int von = 0; von < matrix.length; von++) {
				for (int nach = 0; nach < matrix.length; nach++) {
					for (int ueber = 0; ueber < matrix.length; ueber++) {
						if (!huelle[von][nach] && huelle[von][ueber]
								&& huelle[ueber][nach]) {
							huelle[von][nach] = true;
							veraendert = true;
						}
					}
				}
			}
		} while (veraendert);
		return huelle;
	}

	public static void main(String[] args) {
		boolean[][] matrix = { { false, true, false, true },
				{ false, false, true, false }, { false, true, false, false },
				{ true, false, false, false } };
		boolean[][] huelle = transitiveHuelle(matrix);
		print(matrix);
		print(huelle);
	}

	private static void print(boolean[][] matrix) {
		for (int von = 0; von < matrix.length; von++) {
			for (int nach = 0; nach < matrix.length; nach++) {
				if (matrix[von][nach])
					System.out.print(1);
				else
					System.out.print(0);
			}
			System.out.println();
		}
		System.out.println();
	}
}
