public class UE7Aufgabe49 {

	static final char A = '+'; // Figur Spieler A
	static final char B = 'o'; // Figur Spieler B
	static final char N = '.'; // Feld leer

	public static void main(String[] args) {
		char[][] spielfeld = { { A, A, A, A, A, A, A, A },
				{ A, A, A, A, A, A, A, A }, { N, N, N, N, N, N, N, N },
				{ N, N, N, N, N, N, N, N }, { N, N, N, N, N, N, N, N },
				{ B, B, B, B, B, B, B, B }, { B, B, B, B, B, B, B, B } };
		printSpiefeld(spielfeld);
		boolean aAmZug = true; // Spieler A beginnt
		while (!spielEnde(spielfeld, aAmZug)) {
			System.out.println("Spieler " + (aAmZug ? "A" : "B")
					+ " ist am Zug!");
			int vonReihe = IO.readInt("von Reihe: ");
			int vonSpalte = IO.readInt("von Spalte: ");
			int nachReihe = IO.readInt("nach Reihe: ");
			int nachSpalte = IO.readInt("nach Spalte: ");
			if (!ueberpruefeSpielzug(spielfeld, aAmZug, vonReihe, vonSpalte,
					nachReihe, nachSpalte)) {
				siegerAusgeben(!aAmZug, "Regelversto");
				return; // Spielende
			} else {
				fuehreSpielzugDurch(spielfeld, aAmZug, vonReihe, vonSpalte,
						nachReihe, nachSpalte);
				printSpiefeld(spielfeld);
				aAmZug = !aAmZug; // Spielerwechsel
			}
		}
		siegerAusgeben(!aAmZug, "Ziel erreicht");
	}

	static void printSpiefeld(char[][] feld) {
		// Spieler A
		System.out.println("\n  Spieler A");

		// Nummerierung der Spalten
		System.out.print("  ");
		for (int s = 0; s < feld[0].length; s++) {
			System.out.print(s + " ");
		}
		System.out.println();

		// Feld
		for (int r = 0; r < feld.length; r++) {
			System.out.print(r + " "); // Zeilennummer
			for (int s = 0; s < feld[r].length; s++) {
				System.out.print(feld[r][s] + " ");
			}
			System.out.println();
		}

		// Spieler B
		System.out.println("  Spieler B\n");
	}

	static boolean spielEnde(char[][] feld, boolean aAmZug) {
		// Ziel erreicht
		for (int s = 0; s < feld[0].length; s++) {
			if (feld[0][s] == B) { // Spieler B hat Grundlinie erreicht
				return true;
			}
			if (feld[feld.length - 1][s] == A) { // Spieler A hat Grundlinie
				// erreicht
				return true;
			}
		}

		// keine eigenen Figuren mehr
		int anzahlFiguren = 0;
		for (int r = 0; r < feld.length; r++) {
			for (int s = 0; s < feld[r].length; s++) {
				if (aAmZug && feld[r][s] == A || !aAmZug && feld[r][s] == B) {
					anzahlFiguren++;
				}
			}
		}
		if (anzahlFiguren == 0) {
			return true;
		}

		return false;
	}

	static boolean ueberpruefeSpielzug(char[][] feld, boolean aAmZug,
			int vonReihe, int vonSpalte, int nachReihe, int nachSpalte) {
		// Indizesueberpruefung
		if (vonReihe < 0 || vonReihe >= feld.length || nachReihe < 0
				|| nachReihe >= feld.length || vonSpalte < 0
				|| vonSpalte >= feld[0].length || nachSpalte < 0
				|| nachSpalte >= feld[0].length) {
			return false;
		}

		// Spalte
		if (nachSpalte < vonSpalte - 1 || nachSpalte > vonSpalte + 1) {
			return false;
		}

		if (aAmZug) {
			if (nachReihe != vonReihe + 1) { // Reihe
				return false;
			}
			if (feld[vonReihe][vonSpalte] != A) { // keine eigene Figur
				return false;
			}
			if (feld[nachReihe][nachSpalte] == A) { // eigene Figur
				return false;
			}
		} else {
			if (nachReihe != vonReihe - 1) { // reihe
				return false;
			}
			if (feld[vonReihe][vonSpalte] != B) { // keine eigene Figur
				return false;
			}
			if (feld[nachReihe][nachSpalte] == B) { // eigene Figur
				return false;
			}
		}
		return true;
	}

	static void fuehreSpielzugDurch(char[][] feld, boolean aAmZug,
			int vonReihe, int vonSpalte, int nachReihe, int nachSpalte) {
		feld[vonReihe][vonSpalte] = N;
		if (aAmZug) {
			feld[nachReihe][nachSpalte] = A;
		} else {
			feld[nachReihe][nachSpalte] = B;
		}
	}

	static void siegerAusgeben(boolean siegerA, String grund) {
		String spieler = siegerA ? "A" : "B";
		System.out.println("Sieger ist Spieler " + spieler + "; Grund: "
				+ grund);
	}

}
